#ifndef BRANCHITEM_H
#define BRANCHITEM_H

#include "treeitem.h"

class QString;
class BranchObj;

class BranchItem:public TreeItem
{
public:
    BranchItem(const QList<QVariant> &data, TreeItem *parent = 0);
    ~BranchItem();
	void copy (BranchItem *item);

	QString saveToDir (const QString &tmpdir,const QString &prefix, const QPointF& offset);

	virtual void unScroll();				
	virtual void toggleScroll();			// scroll or unscroll
	virtual bool isScrolled();				// returns scroll state
	virtual bool hasScrolledParent(BranchItem*);	// true, if any of the parents is scrolled
	virtual void tmpUnscroll();				// unscroll scrolled parents temporary e.g. during "find" process
	virtual void resetTmpUnscroll();		// scroll all tmp scrolled parents again e.g. when unselecting

	BranchObj* getBranchObj();	

protected:	
	bool scrolled;			// true if all children are scrolled and thus invisible
	bool tmpUnscrolled;		// can only be true (temporary) for a scrolled subtree

};

#endif
